
// SleepAcc.java
// Andrew Davison, April 2005, ad@fivedots.coe.psu.ac.th

/* Measure the accuracy of sleep() using the Java 3D timer.
*/

import java.text.DecimalFormat;

public class SleepAcc
{
  private static DecimalFormat df;

  public static void main(String args[])
  {
    df = new DecimalFormat("0.##");  // 2 dp

    // test various sleep values
    sleepTest(1000);
    sleepTest(500);
    sleepTest(200);
    sleepTest(100);
    sleepTest(50);
    sleepTest(20);
    sleepTest(10);
    sleepTest(5);
  } // end of main()


  private static void sleepTest(int delay)
  {
    long timeStart = System.nanoTime();

    try {
      Thread.sleep(delay);
    }
    catch(InterruptedException e) {}

    double timeDiff = ((double)(System.nanoTime() - timeStart))/(1000000L);

    System.out.println("Slept: " + delay + " ms  : " + df.format(timeDiff) );
  }  // end of sleepTest()

} // end of SleepAcc class
